unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, FileCtrl, Grids, Outline, ExtCtrls, Buttons,
  HKStreamCol, verslab, CustomRP, NoBDERP;

type
  TMainForm = class(TForm)
    Resizer: TNoBDEResizerPanel;
    Label1: TLabel;
    Bevel2: TBevel;
    Bevel1: TBevel;
    Bevel3: TBevel;
    Bevel6: TBevel;
    Image1: TImage;
    Bevel8: TBevel;
    Bevel9: TBevel;
    DriveComboBox1: TDriveComboBox;
    ReadDiskButton: TButton;
    Outline1: TOutline;
    SaveButton: TButton;
    LoadButton: TButton;
    FindEdit: TEdit;
    ListBox2: TListBox;
    FindButton: TButton;
    StatusBar1: TStatusBar;
    ExportButton: TButton;
    DeleteButton: TButton;
    AddButton: TButton;
    ClearButton: TButton;
    SearchSaveButton: TButton;
    CaseCheck: TCheckBox;
    LoadDefault: TCheckBox;
    DefaultCatalog: TEdit;
    DefaultBrowseButton: TButton;
    AboutButton: TButton;
    ExitButton: TButton;
    Button1: TButton;
    SaveASCII: TSaveDialog;
    SaveDisk: TSaveDialog;
    LoadCatalog: TOpenDialog;
    SaveFind: TSaveDialog;
    LocateDefault: TOpenDialog;
    Timer1: TTimer;
    HKStreams1: THKStreams;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    VersionLabel: TVersionLabel;
    Label9: TLabel;
    CheckHints: TCheckBox;
    Label10: TLabel;
    ProgressBar: TProgressBar;
    procedure SaveButtonClick(Sender: TObject);
    procedure ReadDiskButtonClick(Sender: TObject);
    procedure FindButtonClick(Sender: TObject);
    procedure FindEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ExportButtonClick(Sender: TObject);
    procedure DeleteButtonClick(Sender: TObject);
    procedure ClearButtonClick(Sender: TObject);
    procedure AddButtonClick(Sender: TObject);
    procedure SearchSaveButtonClick(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DefaultBrowseButtonClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure LoadDefaultClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure AboutButtonClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ResizerResize(Sender: TObject);
    procedure CheckHintsClick(Sender: TObject);
  private
    { Private declarations }
    function  IsDiskLabel(line:string):boolean;
    procedure FindDontcare;
    procedure FindDocare;
    procedure ShowStatus(txt : string;waiting : TCursor);
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses HLTools, AboutUnit, ReadTwilightUnit;

{$R *.DFM}

procedure TMainForm.SaveButtonClick(Sender: TObject);
var ms : TMemoryStream;
begin
  if Outline1.Lines.Count=0 then
    begin
      MessageDlg('Sorry, nothing to save: No Catalog.', mtInformation, [mbOk], 0);
      exit;
    end;

  if SaveASCII.Execute then
    begin
      ShowStatus('Saving catalog to disk ...',crHourGlass);

      if SaveASCII.FilterIndex=1 then
        begin
          if pos('.TXT',uppercase(SaveASCII.FileName))=0 then SaveASCII.FileName:=SaveASCII.FileName+'.txt';
            outline1.lines.SaveToFile(SaveASCII.filename);
        end
      else
        begin
          if pos('.CAT',uppercase(SaveASCII.FileName))=0 then SaveASCII.FileName:=SaveASCII.FileName+'.cat';

          ms:=TMemoryStream.Create;

          Outline1.Lines.SaveToStream(ms);
          HKStreams1.AddStream('MEMO1',ms);
          ms.clear;
          HKStreams1.SaveToFile(SaveASCII.FileName);
          HKStreams1.ClearStreams;

          ms.free;

        end;
    end;

  ShowStatus('Currently logged: '+inttostr(outline1.Lines.Count)+' file(s)',crDefault);
end;

procedure TMainForm.ReadDiskButtonClick(Sender: TObject);
var teller, teller2 :integer;
    txt:string;
    MyStrings:TStringList;
begin
  ShowStatus('Scanning media/disk ...',crHourGlass);

  MyStrings:=TStringList.Create;

  MyStrings.Clear;
  MyStrings.Sorted:=true;
  GetDirTree(drivecombobox1.Drive+':\', Mystrings);
  teller2:=0;

  txt:=GetVolumeLabel(drivecombobox1.Drive);

  if (txt='') or (txt=' ') then
    txt:='(no label)';

  Outline1.lines.add(txt+FormatDateTime('" ["dd-mm-yyyy"]"', now()));

  for teller:=0 to MyStrings.Count-1 do
  begin
    txt:=MyStrings.Strings[teller];

    repeat
      inc(teller2);
      txt:=copy(txt,pos('\',txt)+1,length(txt));
    until pos('\',txt)=0;


    repeat
      txt:=' '+txt;
      dec(teller2);
    until teller2=0;

    Outline1.Lines.Add(txt);
  end;

  MyStrings.Clear;
  MyStrings.Free;

  ShowStatus('Currently logged: '+inttostr(outline1.Lines.Count)+' file(s)',crDefault);
end;

function TMainForm.IsDiskLabel(line:string):boolean;
begin
  {identify disklabel, if this starts with a tab=chr(9) then this is NOT a disk label}
  if line[1]=#9 then IsDiskLabel:=false else IsDiskLabel:=true;
end;

procedure TMainForm.FindButtonClick(Sender: TObject);
begin
  ShowStatus('Searching (sub)string ...',crHourGlass);

  if CaseCheck.Checked then
    FindDocare
  else
    FindDontcare;

  ShowStatus('Currently logged: '+inttostr(outline1.Lines.Count)+' file(s)',crDefault);
end;

procedure TMainForm.FindDocare;
var teller : longint;
    disk, regel : string;
begin
  listbox2.Items.Clear;

  ProgressBar.Max:=outline1.lines.Count-1;

  for teller:=0 to outline1.lines.Count-1 do
    begin
      { retrieve disk labels }
      if IsDiskLabel(outline1.Lines[teller]) then
        Disk:=outline1.Lines[teller];

      ProgressBar.position:=teller;
      // locate the sucker
      if pos(FindEdit.Text, outline1.Lines[teller]) > 0 then
        begin
          regel:=outline1.Lines[teller];
          repeat
            regel:=copy(regel,pos(#9,regel)+1,length(regel));
          until IsDiskLabel(regel);

          if Pos(' [',disk)>0 then
            listbox2.items.Add('Disk ['+Copy(disk,1,Pos(' [',disk)-1)+']: File "'+regel+'"')
          else
            listbox2.items.Add('Disk ['+disk+']: File "'+regel+'"')
        end;
    end;

  ProgressBar.Position:=0;
end;

procedure TMainForm.FindDontcare;
var teller : longint;
    disk, regel, zoekstring : string;
begin
  listbox2.Items.Clear;
  zoekstring:=uppercase(FindEdit.Text);
  ProgressBar.max:=outline1.lines.Count-1;

  for teller:=0 to outline1.lines.Count-1 do
    begin
      { retrieve disk labels }
      if IsDiskLabel(outline1.Lines[teller]) then
        Disk:=outline1.Lines[teller];

      ProgressBar.position:=teller;
      if pos(zoekstring, uppercase(outline1.Lines[teller])) > 0 then
        begin
          regel:=outline1.Lines[teller];
          repeat
            regel:=copy(regel,pos(#9,regel)+1,length(regel));
          until IsDiskLabel(regel);
          if Pos(' [',disk)>0 then
            listbox2.items.Add('Disk ['+Copy(disk,1,Pos(' [',disk)-1)+']: File "'+regel+'"')
          else
            listbox2.items.Add('Disk ['+disk+']: File "'+regel+'"')
        end;
    end;

  Progressbar.Position:=0;
end;

procedure TMainForm.FindEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=13 then FindButtonClick(Sender);
end;

procedure TMainForm.ExportButtonClick(Sender: TObject);
var positie : longint;
    MyStrings : TStringList;
    ms : TMemoryStream;
begin
  if Outline1.Lines.Count=0 then
    begin
      MessageDlg('Sorry, no export disk: No Catalog.', mtInformation, [mbOk], 0);
      exit;
    end;

  ShowStatus('Exporting one disk/media to file ...',crHourGlass);
  savedisk.filename:=Copy(Outline1.Lines[Outline1.SelectedItem-1],1,
                          Pos('[',Outline1.Lines[Outline1.SelectedItem-1])-2);

  if SaveDisk.Execute then
    begin
      MyStrings:=TStringList.Create;
      MyStrings.Clear;
      // Make sure extensions are used,...
      if (SaveDisk.FilterIndex=1)and(pos('.TXT',uppercase(SaveDisk.FileName))=0) then
        SaveDisk.FileName:=SaveDisk.FileName+'.txt'
      else if (SaveDisk.FilterIndex=2)and(pos('.CAT',uppercase(SaveDisk.FileName))=0) then
        SaveDisk.FileName:=SaveDisk.FileName+'.cat';

      positie:=Outline1.SelectedItem-1;
      
      repeat
        MyStrings.Add(Outline1.lines[positie]);
        inc(positie);
      until (positie=Outline1.lines.count) or IsDiskLabel(Outline1.lines[positie]);

      if SaveDisk.FilterIndex=1 then // the user choose TXT
        MyStrings.SaveToFile(SaveDisk.filename)
      else
        begin
          ms:=TMemoryStream.Create;

          MyStrings.SaveToStream(ms);
          HKStreams1.AddStream('MEMO1',ms);
          ms.clear;
          HKStreams1.SaveToFile(SaveDisk.FileName);
          HKStreams1.ClearStreams;

          ms.free;
        end; //if

      MyStrings.Clear;
      MyStrings.free;
  end;
  ShowStatus('Currently logged: '+inttostr(outline1.Lines.Count)+' file(s)',crDefault);
end;

procedure TMainForm.DeleteButtonClick(Sender: TObject);
var regel : longint;
begin
  if outline1.Lines.Count<=0 then
    begin
      MessageDlg('Sorry, can''t delete: No Catalog.', mtInformation, [mbOk], 0);
      exit;
    end
  else if Outline1.SelectedItem<=0 then
    begin
      MessageDlg('Sorry, can''t delete: Nothing selected.', mtInformation, [mbOk], 0);
      exit;
    end;

  ShowStatus('Deleting disk/media from catalog ...',crHourGlass);
  regel:=outline1.SelectedItem-1;

  if IsDiskLabel(Outline1.lines[regel]) then
    begin
      {Delete files}
      repeat
        Outline1.Lines.Delete(regel); {Delete disklabel}
      until (regel>=Outline1.lines.count-1) or (IsDiskLabel(Outline1.lines[regel]));

      if Outline1.Lines.Count=0 then ShowStatus('No Catalog loaded ...',crDefault);
    end
  else
    MessageDlg('Sorry, can''t delete: Not a Disk.', mtInformation, [mbOk], 0);

  ShowStatus('Currently logged: '+inttostr(outline1.Lines.Count)+' file(s)',crDefault);
end;

procedure TMainForm.ClearButtonClick(Sender: TObject);
begin
  ShowStatus('Clearing entire catalog ...',crHourGlass);
  outline1.lines.clear;
  outline1.Refresh;
  ShowStatus('No catalog ...',crDefault);
end;

procedure TMainForm.AddButtonClick(Sender: TObject);
var regel : string;
    f: file of Byte;
    MyStrings : TStringList;
    ms : TMemoryStream;
    size,teller : longint;
begin
  if LoadCatalog.Execute then
    begin
      if Sender=LoadButton then
        Outline1.Clear;

      AssignFile(f, LoadCatalog.FileName);
      Reset(f);
      size := FileSize(f);
      closefile(f);

      if FileExists(LoadCatalog.Filename) then
        begin
          MyStrings:=TStringList.Create;
          MyStrings.Clear;
          // MyStrings.Sorted:=true;
          if LoadCatalog.FilterIndex=1 then regel:='ASCII' else regel:='compressed ASCII';

          ShowStatus('Loading/Adding catalog file ... (file size: '+IntToStr(size)+' bytes '+regel+')',crHourGlass);

          if Pos('.TXT',uppercase(LoadCatalog.Filename))>0 then
            MyStrings.LoadFromFile(LoadCatalog.Filename)
          else
            begin
              try
                HKStreams1.LoadFromFile(LoadCatalog.Filename);
              except
                on ECorruptFile do
                  begin
                    MessageDlg('Error: compressed file is corrupt.', mtError, [mbOk], 0);
                    Exit;
                  end;
              end; //try

              ms:=TMemoryStream.Create;

              HKStreams1.GetStream('MEMO1',ms);

              MyStrings.LoadFromStream(ms);
              ms.Clear;

              HKStreams1.ClearStreams;
              ms.free;
            end;  //if

          for teller:=0 to MyStrings.Count-1 do
            Outline1.lines.add(MyStrings.strings[teller]);

          MyStrings.Clear;
          MyStrings.Free;
        end;
    end;
  ShowStatus('Currently logged: '+inttostr(outline1.Lines.Count)+' file(s)',crDefault);
end;

procedure TMainForm.SearchSaveButtonClick(Sender: TObject);
begin
  ShowStatus('Saving search results ...',crHourGlass);
  if ListBox2.Items.Count=0 then
    begin
      MessageDlg('Nothing to save ...', mtInformation, [mbOk], 0);
      exit;
    end;

  if SaveFind.Execute then
    ListBox2.Items.SaveToFile(SaveFind.FileName);

  ShowStatus('Currently logged: '+inttostr(outline1.Lines.Count)+' file(s)',crDefault);
end;

procedure TMainForm.ExitButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ShowStatus('Shutting down ?',crDefault);
  if MessageDlg('Sure you want to exit ?'+#13+#13+'(catalog saved?)',
                mtInformation, [mbOk,mbAbort], 0)=mrOK then
    begin
      SaveRegInteger('AYeah Catalog','Position_Left',self.Left);
      SaveRegInteger('AYeah Catalog','Position_Top',self.Top);
      SaveRegInteger('AYeah Catalog','Position_Height',self.Height);
      SaveRegInteger('AYeah Catalog','Position_Width',self.Width);
      Action := caFree;      { Close app }
    end
  else
    Action := caNone;     { Don't close app }

  ShowStatus('Currently logged: '+inttostr(outline1.Lines.Count)+' file(s)',crDefault);
end;

procedure TMainForm.DefaultBrowseButtonClick(Sender: TObject);
begin
  ShowStatus('Locating suitable directory and file for default catalog ...',crDefault);
  if LocateDefault.Execute then
    begin
      DefaultCatalog.Text:=LocateDefault.FileName;
      LoadDefault.Checked:=true;
      { save to registry }
      SaveRegString('AYeah Catalog','DefaultCatalog',DefaultCatalog.Text);
      SaveRegBool('AYeah Catalog','LoadDefaultCatalog',true);
    end;
  ShowStatus('Currently logged: '+inttostr(outline1.Lines.Count)+' file(s)',crDefault);
end;

procedure TMainForm.ShowStatus(txt : string; waiting : TCursor);
begin
  Cursor:=waiting;
  StatusBar1.panels[1].Text:=txt;
  Repaint;
end;

procedure TMainForm.FormActivate(Sender: TObject);
var ms : TMemoryStream;
    regel : string;
    size : integer;
    f: file of byte;
begin
  ShowStatus('Loading registry data ...',crHourGlass);

  Caption:='AYeah! Catalog - v 1.0 beta ('+VersionLabel.InfoString+') - 1999 Hans Luyten';
  // load registry settings
  if LoadRegInteger('AYeah Catalog','Position_Left')<>0 then
    self.Left:= LoadRegInteger('AYeah Catalog','Position_Left');

  if LoadRegInteger('AYeah Catalog','Position_Top')<>0 then
    self.Top:= LoadRegInteger('AYeah Catalog','Position_Top');

  if LoadRegInteger('AYeah Catalog','Position_Height')<>0 then
    self.Height:= LoadRegInteger('AYeah Catalog','Position_Height');

  if LoadRegInteger('AYeah Catalog','Position_Width')<>0 then
    self.Width:= LoadRegInteger('AYeah Catalog','Position_Width');

  DefaultCatalog.Text:=LoadRegString('AYeah Catalog','DefaultCatalog');
  LoadDefault.Checked:=LoadRegBool('AYeah Catalog','LoadDefaultCatalog');
  Repaint;

  if (LoadDefault.Checked) then
   begin
    AssignFile(f, DefaultCatalog.Text);
    Reset(f);
    size:=FileSize(f);
    closefile(f);

    if pos('.TXT',uppercase(DefaultCatalog.Text))>0 then
      regel:='ASCII'
    else
      regel:='compressed ASCII';

    if (FileExists(DefaultCatalog.Text)) then
      begin
        ShowStatus('Loading default catalog ... (file size: '+IntToStr(size)+' bytes '+regel+')',crHourGlass);
        Repaint;
        
        if Pos('.TXT',uppercase(DefaultCatalog.Text))>0 then
          outline1.lines.LoadFromFile(DefaultCatalog.Text)
        else
          begin
            try
              HKStreams1.LoadFromFile(DefaultCatalog.Text);
            except
              on ECorruptFile do
              begin
                MessageDlg('Error: compressed file is corrupt.', mtError, [mbOk], 0);
                Exit;
              end;
            end;

            ms:=TMemoryStream.Create;

            HKStreams1.GetStream('MEMO1',ms);
            Outline1.Lines.LoadFromStream(ms);
            ms.Clear;

            HKStreams1.ClearStreams;
            ms.free;
          end;
       ShowStatus('Currently logged: '+inttostr(outline1.Lines.Count)+' file(s)',crDefault);
      end
    else
      begin
        MessageDlg('Error: Unable to open default catalog ...',mtError, [mbOk], 0);
        ShowStatus('No catalog ... (failed to open default)',crDefault);
      end;
    end
   else
       ShowStatus('No catalog ...',crDefault);

  CheckHints.checked:=LoadRegBool('AYeah Catalog','ShowHints');
  Resizer.ShowHint:=CheckHints.Checked;
end;

procedure TMainForm.LoadDefaultClick(Sender: TObject);
begin
  SaveRegBool('AYeah Catalog','LoadDefaultCatalog',LoadDefault.checked);
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
  self.StatusBar1.Panels[2].Text:=FormatDateTime(LongDateFormat+' - '+ShortTimeFormat, Now());
end;

procedure TMainForm.AboutButtonClick(Sender: TObject);
begin
  AboutForm.ShowModal;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  if MessageDlg('Please insert the second Twilight disk !'+#13+#13+
                'Make sure you have selected the proper drive !', mtConfirmation, [mbOk, mbCancel], 0) = mrCancel then
    exit
  else
    begin
      ShowStatus('Adding Twilight catalog ...',crDefault);
      TLForm.ShowModal;
    end;
  ShowStatus('Currently logged: '+inttostr(outline1.Lines.Count)+' file(s)',crDefault);
end;

procedure TMainForm.ResizerResize(Sender: TObject);
begin
  Outline1.Font.Size:=9;
  Listbox2.Font.Size:=9;
end;

procedure TMainForm.CheckHintsClick(Sender: TObject);
begin
  Resizer.ShowHint:=CheckHints.Checked;
  SaveRegBool('AYeah Catalog','ShowHints',CheckHints.Checked);
end;

end.
